Imported Upstream version 1.1.2
[platform/upstream/wdiff.git] / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2011 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Diagnostic for continued use of deprecated variable.
25 # Remove in 2013
26 ifneq ($(build_aux),)
27  $(error "$(ME): \
28 set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
29 endif
30
31 # Do not save the original name or timestamp in the .tar.gz file.
32 # Use --rsyncable if available.
33 gzip_rsyncable := \
34   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
35     && printf %s --rsyncable)
36 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
37
38 GIT = git
39 VC = $(GIT)
40
41 VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
42
43 # You can override this variable in cfg.mk to set your own regexp
44 # matching files to ignore.
45 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
46
47 # This is to preprocess robustly the output of $(VC_LIST), so that even
48 # when $(srcdir) is a pathological name like "....", the leading sed command
49 # removes only the intended prefix.
50 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
51
52 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
53 # when $(srcdir) is not ".".
54 ifeq ($(srcdir),.)
55 _prepend_srcdir_prefix =
56 else
57 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
58 endif
59
60 # In order to be able to consistently filter "."-relative names,
61 # (i.e., with no $(srcdir) prefix), this definition is careful to
62 # remove any $(srcdir) prefix, and to restore what it removes.
63 _sc_excl = \
64   $(if $(exclude_file_name_regexp--$@),$(exclude_file_name_regexp--$@),^$$)
65 VC_LIST_EXCEPT = \
66   $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
67         | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
68           else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
69         | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
70         $(_prepend_srcdir_prefix)
71
72 ifeq ($(origin prev_version_file), undefined)
73   prev_version_file = $(srcdir)/.prev-version
74 endif
75
76 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
77 VERSION_REGEXP = $(subst .,\.,$(VERSION))
78 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
79
80 ifeq ($(VC),$(GIT))
81 this-vc-tag = v$(VERSION)
82 this-vc-tag-regexp = v$(VERSION_REGEXP)
83 else
84 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
85 tag-this-version = $(subst .,_,$(VERSION))
86 this-vc-tag = $(tag-package)-$(tag-this-version)
87 this-vc-tag-regexp = $(this-vc-tag)
88 endif
89 my_distdir = $(PACKAGE)-$(VERSION)
90
91 # Old releases are stored here.
92 release_archive_dir ?= ../release
93
94 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
95 # Use alpha.gnu.org for alpha and beta releases.
96 # Use ftp.gnu.org for stable releases.
97 gnu_ftp_host-alpha = alpha.gnu.org
98 gnu_ftp_host-beta = alpha.gnu.org
99 gnu_ftp_host-stable = ftp.gnu.org
100 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
101
102 ifeq ($(gnu_rel_host),ftp.gnu.org)
103 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
104 else
105 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
106 endif
107
108 # Override this in cfg.mk if you are using a different format in your
109 # NEWS file.
110 today = $(shell date +%Y-%m-%d)
111
112 # Select which lines of NEWS are searched for $(news-check-regexp).
113 # This is a sed line number spec.  The default says that we search
114 # lines 1..10 of NEWS for $(news-check-regexp).
115 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
116 news-check-lines-spec ?= 1,10
117 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
118
119 # Prevent programs like 'sort' from considering distinct strings to be equal.
120 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
121 export LC_ALL = C
122
123 ## --------------- ##
124 ## Sanity checks.  ##
125 ## --------------- ##
126
127 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
128
129 # Collect the names of rules starting with `sc_'.
130 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
131                         $(srcdir)/$(ME) $(_cfg_mk)))
132 .PHONY: $(syntax-check-rules)
133
134 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
135 local-checks-available += $(syntax-check-rules)
136 else
137 local-checks-available += no-vc-detected
138 no-vc-detected:
139         @echo "No version control files detected; skipping syntax check"
140 endif
141 .PHONY: $(local-checks-available)
142
143 # Arrange to print the name of each syntax-checking rule just before running it.
144 $(syntax-check-rules): %: %.m
145 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
146 .PHONY: $(sc_m_rules_)
147 $(sc_m_rules_):
148         @echo $(patsubst sc_%.m, %, $@)
149         @date +%s.%N > .sc-start-$(basename $@)
150         @echo -ne '\e[31m'
151
152 # Compute and print the elapsed time for each syntax-check rule.
153 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
154 .PHONY: $(sc_z_rules_)
155 $(sc_z_rules_): %.z: %
156         @echo -ne '\e[0m'
157         @end=$$(date +%s.%N);                                           \
158         start=$$(cat .sc-start-$*);                                     \
159         rm -f .sc-start-$*;                                             \
160         awk -v s=$$start -v e=$$end                                     \
161           'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
162
163 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
164 # that computes and prints elapsed time.
165 local-check :=                                                          \
166   $(patsubst sc_%, sc_%.z,                                              \
167     $(filter-out $(local-checks-to-skip), $(local-checks-available)))
168
169 syntax-check:
170         @$(VC_LIST) > .vc.list
171         @$(MAKE) -k $(local-check) VC_LIST='cat .vc.list'
172         @$(RM) .vc.list
173
174 # _sc_search_regexp
175 #
176 # This macro searches for a given construct in the selected files and
177 # then takes some action.
178 #
179 # Parameters (shell variables):
180 #
181 #  prohibit | require
182 #
183 #     Regular expression (ERE) denoting either a forbidden construct
184 #     or a required construct.  Those arguments are exclusive.
185 #
186 #  in_vc_files | in_files
187 #
188 #     grep-E-style regexp denoting the files to check.  If no files
189 #     are specified the default are all the files that are under
190 #     version control.
191 #
192 #  containing | non_containing
193 #
194 #     Select the files (non) containing strings matching this regexp.
195 #     If both arguments are specified then CONTAINING takes
196 #     precedence.
197 #
198 #  with_grep_options
199 #
200 #     Extra options for grep.
201 #
202 #  ignore_case
203 #
204 #     Ignore case.
205 #
206 #  halt
207 #
208 #     Message to display before to halting execution.
209 #
210 # Finally, you may exempt files based on an ERE matching file names.
211 # For example, to exempt from the sc_space_tab check all files with the
212 # .diff suffix, set this Make variable:
213 #
214 # exclude_file_name_regexp--sc_space_tab = \.diff$
215 #
216 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
217 # when filtering by name via in_files, we explicitly filter out matching
218 # names here as well.
219
220 # By default, _sc_search_regexp does not ignore case.
221 export ignore_case =
222 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
223
224 define _sc_say_and_exit
225    dummy=; : so we do not need a semicolon before each use;             \
226    { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
227 endef
228
229 # _sc_search_regexp used to be named _prohibit_regexp.  However,
230 # upgrading to the new definition and leaving the old name undefined
231 # would usually convert each custom rule using $(_prohibit_regexp)
232 # (usually defined in cfg.mk) into a no-op.  This definition ensures
233 # that people know right away if they're still using the old name.
234 # FIXME: remove in 2012.
235 _prohibit_regexp = \
236   $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
237
238 define _sc_search_regexp
239    dummy=; : so we do not need a semicolon before each use;             \
240                                                                         \
241    : Check arguments;                                                   \
242    test -n "$$prohibit" && test -n "$$require"                          \
243      && { msg='Cannot specify both prohibit and require'                \
244           $(_sc_say_and_exit) } || :;                                   \
245    test -z "$$prohibit" && test -z "$$require"                          \
246      && { msg='Should specify either prohibit or require'               \
247           $(_sc_say_and_exit) } || :;                                   \
248    test -n "$$in_vc_files" && test -n "$$in_files"                      \
249      && { msg='Cannot specify both in_vc_files and in_files'            \
250           $(_sc_say_and_exit) } || :;                                   \
251    test "x$$halt" != x                                                  \
252      || { msg='halt not defined' $(_sc_say_and_exit) };                 \
253                                                                         \
254    : Filter by file name;                                               \
255    if test -n "$$in_files"; then                                        \
256      files=$$(find $(srcdir) | grep -E "$$in_files"                     \
257               | grep -Ev '$(exclude_file_name_regexp--$@)');            \
258    else                                                                 \
259      files=$$($(VC_LIST_EXCEPT));                                       \
260      if test -n "$$in_vc_files"; then                                   \
261        files=$$(echo "$$files" | grep -E "$$in_vc_files");              \
262      fi;                                                                \
263    fi;                                                                  \
264                                                                         \
265    : Filter by content;                                                 \
266    test -n "$$files" && test -n "$$containing"                          \
267      && { files=$$(grep -l "$$containing" $$files); } || :;             \
268    test -n "$$files" && test -n "$$non_containing"                      \
269      && { files=$$(grep -vl "$$non_containing" $$files); } || :;        \
270                                                                         \
271    : Check for the construct;                                           \
272    if test -n "$$files"; then                                           \
273      if test -n "$$prohibit"; then                                      \
274        grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
275          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
276      else                                                               \
277        grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
278            | grep .                                                     \
279          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
280      fi                                                                 \
281    else :;                                                              \
282    fi || :;
283 endef
284
285 sc_avoid_if_before_free:
286         @$(srcdir)/$(_build-aux)/useless-if-before-free                 \
287                 $(useless_free_options)                                 \
288             $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) &&   \
289           { echo '$(ME): found useless "if" before "free" above' 1>&2;  \
290             exit 1; } || :
291
292 sc_cast_of_argument_to_free:
293         @prohibit='\<free *\( *\(' halt='don'\''t cast free argument'   \
294           $(_sc_search_regexp)
295
296 sc_cast_of_x_alloc_return_value:
297         @prohibit='\*\) *x(m|c|re)alloc\>'                              \
298         halt='don'\''t cast x*alloc return value'                       \
299           $(_sc_search_regexp)
300
301 sc_cast_of_alloca_return_value:
302         @prohibit='\*\) *alloca\>'                                      \
303         halt='don'\''t cast alloca return value'                        \
304           $(_sc_search_regexp)
305
306 sc_space_tab:
307         @prohibit='[ ]  '                                               \
308         halt='found SPACE-TAB sequence; remove the SPACE'               \
309           $(_sc_search_regexp)
310
311 INDENT_STYLE ?= -gnu
312
313 sc_indent:
314 ifneq ($(strip $(INDENT_STYLE)),)
315         @fail=0;                                                        \
316         for file in $$($(VC_LIST_EXCEPT)); do                           \
317           case $$file in                                                \
318             *.c|*.h)                                                    \
319               if ! indent $(INDENT_STYLE) -st "$$file" |                \
320                    diff -u --label "$$file" -p "$$file" -; then         \
321                 fail=1;                                                 \
322               fi                                                        \
323               ;;                                                        \
324           esac                                                          \
325         done;                                                           \
326         test $$fail = 1 &&                                              \
327           { echo '$(ME): the above changes should be applied'           \
328             'in order to unify the coding style' 1>&2; exit 1; } || :
329 else
330         @:
331 endif
332
333 # Don't use *scanf or the old ato* functions in `real' code.
334 # They provide no error checking mechanism.
335 # Instead, use strto* functions.
336 sc_prohibit_atoi_atof:
337         @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\('                           \
338         halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q'   \
339           $(_sc_search_regexp)
340
341 # Use STREQ rather than comparing strcmp == 0, or != 0.
342 sc_prohibit_strcmp:
343         @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]='   \
344             $$($(VC_LIST_EXCEPT))                                       \
345           | grep -vE ':# *define STRN?EQ\(' &&                          \
346           { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \
347                 1>&2; exit 1; } || :
348
349 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
350 # Convert all uses automatically, via these two commands:
351 # git grep -l '\<exit *(1)' \
352 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
353 #  | xargs --no-run-if-empty \
354 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
355 # git grep -l '\<exit *(0)' \
356 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
357 #  | xargs --no-run-if-empty \
358 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
359 sc_prohibit_magic_number_exit:
360         @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,'     \
361         halt='use EXIT_* values rather than magic number'                       \
362           $(_sc_search_regexp)
363
364 # Using EXIT_SUCCESS as the first argument to error is misleading,
365 # since when that parameter is 0, error does not exit.  Use `0' instead.
366 sc_error_exit_success:
367         @prohibit='error *\(EXIT_SUCCESS,'                              \
368         in_vc_files='\.[chly]$$'                                        \
369         halt='found error (EXIT_SUCCESS'                                \
370          $(_sc_search_regexp)
371
372 # `FATAL:' should be fully upper-cased in error messages
373 # `WARNING:' should be fully upper-cased, or fully lower-cased
374 sc_error_message_warn_fatal:
375         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
376             | grep -E '"Warning|"Fatal|"fatal' &&                       \
377           { echo '$(ME): use FATAL, WARNING or warning' 1>&2;           \
378             exit 1; } || :
379
380 # Error messages should not start with a capital letter
381 sc_error_message_uppercase:
382         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
383             | grep -E '"[A-Z]'                                          \
384             | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' &&           \
385           { echo '$(ME): found capitalized error message' 1>&2;         \
386             exit 1; } || :
387
388 # Error messages should not end with a period
389 sc_error_message_period:
390         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
391             | grep -E '[^."]\."' &&                                     \
392           { echo '$(ME): found error message ending in period' 1>&2;    \
393             exit 1; } || :
394
395 sc_file_system:
396         @prohibit=file''system                                          \
397         ignore_case=1                                                   \
398         halt='found use of "file''system"; spell it "file system"'      \
399           $(_sc_search_regexp)
400
401 # Don't use cpp tests of this symbol.  All code assumes config.h is included.
402 sc_prohibit_have_config_h:
403         @prohibit='^# *if.*HAVE''_CONFIG_H'                             \
404         halt='found use of HAVE''_CONFIG_H; remove'                     \
405           $(_sc_search_regexp)
406
407 # Nearly all .c files must include <config.h>.  However, we also permit this
408 # via inclusion of a package-specific header, if cfg.mk specified one.
409 # config_h_header must be suitable for grep -E.
410 config_h_header ?= <config\.h>
411 sc_require_config_h:
412         @require='^# *include $(config_h_header)'                       \
413         in_vc_files='\.c$$'                                             \
414         halt='the above files do not include <config.h>'                \
415           $(_sc_search_regexp)
416
417 # You must include <config.h> before including any other header file.
418 # This can possibly be via a package-specific header, if given by cfg.mk.
419 sc_require_config_h_first:
420         @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then       \
421           fail=0;                                                       \
422           for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do             \
423             grep '^# *include\>' $$i | sed 1q                           \
424                 | grep -E '^# *include $(config_h_header)' > /dev/null  \
425               || { echo $$i; fail=1; };                                 \
426           done;                                                         \
427           test $$fail = 1 &&                                            \
428             { echo '$(ME): the above files include some other header'   \
429                 'before <config.h>' 1>&2; exit 1; } || :;               \
430         else :;                                                         \
431         fi
432
433 sc_prohibit_HAVE_MBRTOWC:
434         @prohibit='\bHAVE_MBRTOWC\b'                                    \
435         halt="do not use $$prohibit; it is always defined"              \
436           $(_sc_search_regexp)
437
438 # To use this "command" macro, you must first define two shell variables:
439 # h: the header name, with no enclosing <> or ""
440 # re: a regular expression that matches IFF something provided by $h is used.
441 define _sc_header_without_use
442   dummy=; : so we do not need a semicolon before each use;              \
443   h_esc=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`;                    \
444   if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then              \
445     files=$$(grep -l '^# *include '"$$h_esc"                            \
446              $$($(VC_LIST_EXCEPT) | grep '\.c$$')) &&                   \
447     grep -LE "$$re" $$files | grep . &&                                 \
448       { echo "$(ME): the above files include $$h but don't use it"      \
449         1>&2; exit 1; } || :;                                           \
450   else :;                                                               \
451   fi
452 endef
453
454 # Prohibit the inclusion of assert.h without an actual use of assert.
455 sc_prohibit_assert_without_use:
456         @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
457
458 # Prohibit the inclusion of close-stream.h without an actual use.
459 sc_prohibit_close_stream_without_use:
460         @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
461
462 # Prohibit the inclusion of getopt.h without an actual use.
463 sc_prohibit_getopt_without_use:
464         @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
465
466 # Don't include quotearg.h unless you use one of its functions.
467 sc_prohibit_quotearg_without_use:
468         @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
469
470 # Don't include quote.h unless you use one of its functions.
471 sc_prohibit_quote_without_use:
472         @h='quote.h' re='\<quote(_n)? *\(' $(_sc_header_without_use)
473
474 # Don't include this header unless you use one of its functions.
475 sc_prohibit_long_options_without_use:
476         @h='long-options.h' re='\<parse_long_options *\(' \
477           $(_sc_header_without_use)
478
479 # Don't include this header unless you use one of its functions.
480 sc_prohibit_inttostr_without_use:
481         @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
482           $(_sc_header_without_use)
483
484 # Don't include this header unless you use one of its functions.
485 sc_prohibit_ignore_value_without_use:
486         @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
487           $(_sc_header_without_use)
488
489 # Don't include this header unless you use one of its functions.
490 sc_prohibit_error_without_use:
491         @h='error.h' \
492         re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
493           $(_sc_header_without_use)
494
495 # Don't include xalloc.h unless you use one of its functions.
496 # Consider these symbols:
497 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
498 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
499 # Divide into two sets on case, and filter each through this:
500 # | sort | perl -MRegexp::Assemble -le \
501 #  'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
502 # Note this was produced by the above:
503 # _xa1 = \
504 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
505 # But we can do better, in at least two ways:
506 # 1) take advantage of two "dup"-suffixed strings:
507 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
508 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
509 # "char|[cmz]"
510 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
511 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
512 _xa2 = X([CZ]|N?M)ALLOC
513 sc_prohibit_xalloc_without_use:
514         @h='xalloc.h' \
515         re='\<($(_xa1)|$(_xa2)) *\('\
516           $(_sc_header_without_use)
517
518 # Extract function names:
519 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
520 _hash_re = \
521 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
522 _hash_fn = \<($(_hash_re)) *\(
523 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
524 sc_prohibit_hash_without_use:
525         @h='hash.h' \
526         re='$(_hash_fn)|$(_hash_struct)'\
527           $(_sc_header_without_use)
528
529 sc_prohibit_cloexec_without_use:
530         @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
531           $(_sc_header_without_use)
532
533 sc_prohibit_posixver_without_use:
534         @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
535
536 sc_prohibit_same_without_use:
537         @h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
538
539 sc_prohibit_hash_pjw_without_use:
540         @h='hash-pjw.h' \
541         re='\<hash_pjw *\(' \
542           $(_sc_header_without_use)
543
544 sc_prohibit_safe_read_without_use:
545         @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
546           $(_sc_header_without_use)
547
548 sc_prohibit_argmatch_without_use:
549         @h='argmatch.h' \
550         re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
551           $(_sc_header_without_use)
552
553 sc_prohibit_canonicalize_without_use:
554         @h='canonicalize.h' \
555         re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
556           $(_sc_header_without_use)
557
558 sc_prohibit_root_dev_ino_without_use:
559         @h='root-dev-ino.h' \
560         re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
561           $(_sc_header_without_use)
562
563 sc_prohibit_openat_without_use:
564         @h='openat.h' \
565         re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
566           $(_sc_header_without_use)
567
568 # Prohibit the inclusion of c-ctype.h without an actual use.
569 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
570 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
571 sc_prohibit_c_ctype_without_use:
572         @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
573           $(_sc_header_without_use)
574
575 _empty =
576 _sp = $(_empty) $(_empty)
577 # The following list was generated by running:
578 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
579 #   | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
580 _sig_functions = \
581   bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
582   sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
583   siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
584   sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
585 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
586 # The following were extracted from "man signal.h" manually.
587 _sig_types_and_consts =                                                 \
588   MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK           \
589   SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL            \
590   SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE    \
591   SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t  \
592   sigstack sigval stack_t ucontext_t
593 # generated via this:
594 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
595 _sig_names =                                                            \
596   SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT      \
597   SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL       \
598   SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP  \
599   SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR      \
600   SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS   \
601   SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1        \
602   SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW       \
603   SIGXCPU SIGXFSZ
604 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
605
606 # Prohibit the inclusion of signal.h without an actual use.
607 sc_prohibit_signal_without_use:
608         @h='signal.h'                                                   \
609         re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>'          \
610           $(_sc_header_without_use)
611
612 # Don't include stdio--.h unless you use one of its functions.
613 sc_prohibit_stdio--_without_use:
614         @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\('              \
615           $(_sc_header_without_use)
616
617 # Don't include stdio-safer.h unless you use one of its functions.
618 sc_prohibit_stdio-safer_without_use:
619         @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\('    \
620           $(_sc_header_without_use)
621
622 # Prohibit the inclusion of strings.h without a sensible use.
623 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
624 sc_prohibit_strings_without_use:
625         @h='strings.h'                                                  \
626         re='\<(strn?casecmp|ffs(ll)?)\>'                                \
627           $(_sc_header_without_use)
628
629 # Get the list of symbol names with this:
630 # perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
631 _intprops_names =                                                       \
632   TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT             \
633   TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM           \
634   INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND              \
635   INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW                    \
636   INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW                 \
637   INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW                \
638   INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW  \
639   INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW         \
640   INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
641 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
642 # Prohibit the inclusion of intprops.h without an actual use.
643 sc_prohibit_intprops_without_use:
644         @h='intprops.h'                                                 \
645         re='\<($(_intprops_syms_re)) *\('                               \
646           $(_sc_header_without_use)
647
648 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
649 # Prohibit the inclusion of stddef.h without an actual use.
650 sc_prohibit_stddef_without_use:
651         @h='stddef.h'                                                   \
652         re='\<($(_stddef_syms_re))\>'                                   \
653           $(_sc_header_without_use)
654
655 _de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
656 _de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
657 _de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
658 _dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
659 # Prohibit the inclusion of dirent.h without an actual use.
660 sc_prohibit_dirent_without_use:
661         @h='dirent.h'                                                   \
662         re='\<($(_dirent_syms_re))\>'                                   \
663           $(_sc_header_without_use)
664
665 # Prohibit the inclusion of verify.h without an actual use.
666 sc_prohibit_verify_without_use:
667         @h='verify.h'                                                   \
668         re='\<(verify(true|expr)?|static_assert) *\('                   \
669           $(_sc_header_without_use)
670
671 # Don't include xfreopen.h unless you use one of its functions.
672 sc_prohibit_xfreopen_without_use:
673         @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
674
675 sc_obsolete_symbols:
676         @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                     \
677         halt='do not use HAVE''_FCNTL_H or O'_NDELAY                    \
678           $(_sc_search_regexp)
679
680 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
681
682 # Each nonempty ChangeLog line must start with a year number, or a TAB.
683 sc_changelog:
684         @prohibit='^[^12        ]'                                      \
685         in_vc_files='^ChangeLog$$'                                      \
686         halt='found unexpected prefix in a ChangeLog'                   \
687           $(_sc_search_regexp)
688
689 # Ensure that each .c file containing a "main" function also
690 # calls set_program_name.
691 sc_program_name:
692         @require='set_program_name *\(m?argv\[0\]\);'                   \
693         in_vc_files='\.c$$'                                             \
694         containing='\<main *('                                          \
695         halt='the above files do not call set_program_name'             \
696           $(_sc_search_regexp)
697
698 # Ensure that each .c file containing a "main" function also
699 # calls bindtextdomain.
700 sc_bindtextdomain:
701         @require='bindtextdomain *\('                                   \
702         in_vc_files='\.c$$'                                             \
703         containing='\<main *('                                          \
704         halt='the above files do not call bindtextdomain'               \
705           $(_sc_search_regexp)
706
707 # Require that the final line of each test-lib.sh-using test be this one:
708 # Exit $fail
709 # Note: this test requires GNU grep's --label= option.
710 Exit_witness_file ?= tests/test-lib.sh
711 Exit_base := $(notdir $(Exit_witness_file))
712 sc_require_test_exit_idiom:
713         @if test -f $(srcdir)/$(Exit_witness_file); then                \
714           die=0;                                                        \
715           for i in $$(grep -l -F 'srcdir/$(Exit_base)'                  \
716                 $$($(VC_LIST) tests)); do                               \
717             tail -n1 $$i | grep '^Exit .' > /dev/null                   \
718               && : || { die=1; echo $$i; }                              \
719           done;                                                         \
720           test $$die = 1 &&                                             \
721             { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
722               echo 1>&2 'Exit something';                               \
723               exit 1; } || :;                                           \
724         fi
725
726 sc_trailing_blank:
727         @prohibit='[     ]$$'                                           \
728         halt='found trailing blank(s)'                                  \
729           $(_sc_search_regexp)
730
731 # Match lines like the following, but where there is only one space
732 # between the options and the description:
733 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
734 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
735 sc_two_space_separator_in_usage:
736         @prohibit='^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
737         halt='help2man requires at least two spaces between an option and its description'\
738           $(_sc_search_regexp)
739
740 # A regexp matching function names like "error" that may be used
741 # to emit translatable messages.
742 _gl_translatable_diag_func_re ?= error
743
744 # Look for diagnostics that aren't marked for translation.
745 # This won't find any for which error's format string is on a separate line.
746 sc_unmarked_diagnostics:
747         @grep -nE                                                       \
748             '\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
749                 $$($(VC_LIST_EXCEPT))                                   \
750           | grep -Ev '(_|ngettext ?)\(' &&                              \
751           { echo '$(ME): found unmarked diagnostic(s)' 1>&2;            \
752             exit 1; } || :
753
754 # Avoid useless parentheses like those in this example:
755 # #if defined (SYMBOL) || defined (SYM2)
756 sc_useless_cpp_parens:
757         @prohibit='^# *if .*defined *\('                                \
758         halt='found useless parentheses in cpp directive'               \
759           $(_sc_search_regexp)
760
761 # List headers for which HAVE_HEADER_H is always true, assuming you are
762 # using the appropriate gnulib module.  CAUTION: for each "unnecessary"
763 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
764 # requires the gnulib module that guarantees the usability of that header.
765 gl_assured_headers_ = \
766   cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
767
768 # Convert the list of names to upper case, and replace each space with "|".
769 az_ = abcdefghijklmnopqrstuvwxyz
770 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
771 gl_header_upper_case_or_ =                                              \
772   $$($(gl_assured_headers_)                                             \
773     | tr $(az_)/.- $(AZ_)___                                            \
774     | tr -s ' ' '|'                                                     \
775     )
776 sc_prohibit_always_true_header_tests:
777         @or=$(gl_header_upper_case_or_);                                \
778         re="HAVE_($$or)_H";                                             \
779         prohibit='\<'"$$re"'\>'                                         \
780         halt=$$(printf '%s\n'                                           \
781         'do not test the above HAVE_<header>_H symbol(s);'              \
782         '  with the corresponding gnulib module, they are always true') \
783           $(_sc_search_regexp)
784
785 # ==================================================================
786 gl_other_headers_ ?= \
787   intprops.h    \
788   openat.h      \
789   stat-macros.h
790
791 # Perl -lne code to extract "significant" cpp-defined symbols from a
792 # gnulib header file, eliminating a few common false-positives.
793 # The exempted names below are defined only conditionally in gnulib,
794 # and hence sometimes must/may be defined in application code.
795 gl_extract_significant_defines_ = \
796   /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
797     && $$2 !~ /(?:rpl_|_used_without_)/\
798     && $$1 !~ /^(?:NSIG|ENODATA)$$/\
799     && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
800     and print $$1
801
802 # Create a list of regular expressions matching the names
803 # of macros that are guaranteed to be defined by parts of gnulib.
804 define def_sym_regex
805         gen_h=$(gl_generated_headers_);                                 \
806         (cd $(gnulib_dir)/lib;                                          \
807           for f in *.in.h $(gl_other_headers_); do                      \
808             test -f $$f                                                 \
809               && perl -lne '$(gl_extract_significant_defines_)' $$f;    \
810           done;                                                         \
811         ) | sort -u                                                     \
812           | sed 's/^/^ *# *(define|undef)  */;s/$$/\\>/'
813 endef
814
815 # Don't define macros that we already get from gnulib header files.
816 sc_prohibit_always-defined_macros:
817         @if test -d $(gnulib_dir); then                                 \
818           case $$(echo all: | grep -l -f - Makefile) in Makefile);; *)  \
819             echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
820           esac;                                                         \
821           $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT))         \
822             && { echo '$(ME): define the above via some gnulib .h file' \
823                   1>&2;  exit 1; } || :;                                \
824         fi
825 # ==================================================================
826
827 # Prohibit checked in backup files.
828 sc_prohibit_backup_files:
829         @$(VC_LIST) | grep '~$$' &&                             \
830           { echo '$(ME): found version controlled backup file' 1>&2;    \
831             exit 1; } || :
832
833 # Require the latest GPL.
834 sc_GPL_version:
835         @prohibit='either ''version [^3]'                               \
836         halt='GPL vN, N!=3'                                             \
837           $(_sc_search_regexp)
838
839 # Require the latest GFDL.  Two regexp, since some .texi files end up
840 # line wrapping between 'Free Documentation License,' and 'Version'.
841 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
842 sc_GFDL_version:
843         @prohibit='$(_GFDL_regexp)'                                     \
844         halt='GFDL vN, N!=3'                                            \
845           $(_sc_search_regexp)
846
847 # Don't use Texinfo's @acronym{}.
848 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
849 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
850 sc_texinfo_acronym:
851         @prohibit='@acronym\{'                                          \
852         in_vc_files='$(texinfo_suffix_re_)'                             \
853         halt='found use of Texinfo @acronym{}'                          \
854           $(_sc_search_regexp)
855
856 cvs_keywords = \
857   Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
858
859 sc_prohibit_cvs_keyword:
860         @prohibit='\$$($(cvs_keywords))\$$'                             \
861         halt='do not use CVS keyword expansion'                         \
862           $(_sc_search_regexp)
863
864 # This Perl code is slightly obfuscated.  Not only is each "$" doubled
865 # because it's in a Makefile, but the $$c's are comments;  we cannot
866 # use "#" due to the way the script ends up concatenated onto one line.
867 # It would be much more concise, and would produce better output (including
868 # counts) if written as:
869 #   perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
870 # but that would be far less efficient, reading the entire contents
871 # of each file, rather than just the last two bytes of each.
872 # In addition, while the code below detects both blank lines and a missing
873 # newline at EOF, the above detects only the former.
874 #
875 # This is a perl script that is expected to be the single-quoted argument
876 # to a command-line "-le".  The remaining arguments are file names.
877 # Print the name of each file that ends in exactly one newline byte.
878 # I.e., warn if there are blank lines (2 or more newlines), or if the
879 # last byte is not a newline.  However, currently we don't complain
880 # about any file that contains exactly one byte.
881 # Exit nonzero if at least one such file is found, otherwise, exit 0.
882 # Warn about, but otherwise ignore open failure.  Ignore seek/read failure.
883 #
884 # Use this if you want to remove trailing empty lines from selected files:
885 #   perl -pi -0777 -e 's/\n\n+$/\n/' files...
886 #
887 require_exactly_one_NL_at_EOF_ =                                        \
888   foreach my $$f (@ARGV)                                                \
889     {                                                                   \
890       open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next;     \
891       my $$p = sysseek (F, -2, 2);                                      \
892       my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
893       my $$last_two_bytes;                                              \
894       defined $$p and $$p = sysread F, $$last_two_bytes, 2;             \
895       close F;                                                          \
896       $$c = "ignore read failure";                                      \
897       $$p && ($$last_two_bytes eq "\n\n"                                \
898               || substr ($$last_two_bytes,1) ne "\n")                   \
899           and (print $$f), $$fail=1;                                    \
900     }                                                                   \
901   END { exit defined $$fail }
902 sc_prohibit_empty_lines_at_EOF:
903         @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
904           || { echo '$(ME): empty line(s) or no newline at EOF'         \
905                 1>&2; exit 1; } || :
906
907 # Make sure we don't use st_blocks.  Use ST_NBLOCKS instead.
908 # This is a bit of a kludge, since it prevents use of the string
909 # even in comments, but for now it does the job with no false positives.
910 sc_prohibit_stat_st_blocks:
911         @prohibit='[.>]st_blocks'                                       \
912         halt='do not use st_blocks; use ST_NBLOCKS'                     \
913           $(_sc_search_regexp)
914
915 # Make sure we don't define any S_IS* macros in src/*.c files.
916 # They're already defined via gnulib's sys/stat.h replacement.
917 sc_prohibit_S_IS_definition:
918         @prohibit='^ *# *define  *S_IS'                                 \
919         halt='do not define S_IS* macros; include <sys/stat.h>'         \
920           $(_sc_search_regexp)
921
922 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
923 # that is shared by two definitions below.
924 perl_filename_lineno_text_ =                                            \
925     -e '  {'                                                            \
926     -e '    $$n = ($$` =~ tr/\n/\n/ + 1);'                              \
927     -e '    ($$v = $$&) =~ s/\n/\\n/g;'                                 \
928     -e '    print "$$ARGV:$$n:$$v\n";'                                  \
929     -e '  }'
930
931 prohibit_doubled_word_RE_ ?= \
932   /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
933 prohibit_doubled_word_ =                                                \
934     -e 'while ($(prohibit_doubled_word_RE_))'                           \
935     $(perl_filename_lineno_text_)
936
937 # Define this to a regular expression that matches
938 # any filename:dd:match lines you want to ignore.
939 # The default is to ignore no matches.
940 ignore_doubled_word_match_RE_ ?= ^$$
941
942 sc_prohibit_doubled_word:
943         @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT))  \
944           | grep -vE '$(ignore_doubled_word_match_RE_)'                 \
945           | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
946
947 # A regular expression matching undesirable combinations of words like
948 # "can not"; this matches them even when the two words appear on different
949 # lines, but not when there is an intervening delimiter like "#" or "*".
950 prohibit_undesirable_word_seq_RE_ ?=                                    \
951   /\bcan\s+not\b/gims
952 prohibit_undesirable_word_seq_ =                                        \
953     -e 'while ($(prohibit_undesirable_word_seq_RE_))'                   \
954     $(perl_filename_lineno_text_)
955 # Define this to a regular expression that matches
956 # any filename:dd:match lines you want to ignore.
957 # The default is to ignore no matches.
958 ignore_undesirable_word_sequence_RE_ ?= ^$$
959
960 sc_prohibit_undesirable_word_seq:
961         @perl -n -0777 $(prohibit_undesirable_word_seq_)                \
962              $$($(VC_LIST_EXCEPT))                                      \
963           | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
964           && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
965
966 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
967 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
968 # Using test's -a and -o operators is not portable.
969 # We prefer test over [, since the latter is spelled [[ in configure.ac.
970 sc_prohibit_test_minus_ao:
971         @prohibit='(\<test| \[+) .+ -[ao] '                             \
972         halt='$(_ptm1); $(_ptm2)'                                       \
973           $(_sc_search_regexp)
974
975 # Avoid a test bashism.
976 sc_prohibit_test_double_equal:
977         @prohibit='(\<test| \[+) .+ == '                                \
978         containing='#! */bin/[a-z]*sh'                                  \
979         halt='use "test x = x", not "test x =''= x"'                    \
980           $(_sc_search_regexp)
981
982 # Each program that uses proper_name_utf8 must link with one of the
983 # ICONV libraries.  Otherwise, some ICONV library must appear in LDADD.
984 # The perl -0777 invocation below extracts the possibly-multi-line
985 # definition of LDADD from the appropriate Makefile.am and exits 0
986 # when it contains "ICONV".
987 sc_proper_name_utf8_requires_ICONV:
988         @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
989         if test "x$$progs" != x; then                                   \
990           fail=0;                                                       \
991           for p in $$progs; do                                          \
992             dir=$$(dirname "$$p");                                      \
993             perl -0777                                                  \
994               -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)'  \
995               $$dir/Makefile.am && continue;                            \
996             base=$$(basename "$$p" .c);                                 \
997             grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
998               || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
999           done;                                                         \
1000           test $$fail = 1 &&                                            \
1001             { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
1002               exit 1; } || :;                                           \
1003         fi
1004
1005 # Warn about "c0nst struct Foo const foo[]",
1006 # but not about "char const *const foo" or "#define const const".
1007 sc_redundant_const:
1008         @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b'          \
1009         halt='redundant "const" in declarations'                        \
1010           $(_sc_search_regexp)
1011
1012 sc_const_long_option:
1013         @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT))         \
1014           | grep -Ev 'const struct option|struct option const' && {     \
1015               echo 1>&2 '$(ME): add "const" to the above declarations'; \
1016               exit 1; } || :
1017
1018 NEWS_hash =                                                             \
1019   $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p'              \
1020        $(srcdir)/NEWS                                                   \
1021      | perl -0777 -pe                                                   \
1022         's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms'       \
1023      | md5sum -                                                         \
1024      | sed 's/ .*//')
1025
1026 # Ensure that we don't accidentally insert an entry into an old NEWS block.
1027 sc_immutable_NEWS:
1028         @if test -f $(srcdir)/NEWS; then                                \
1029           test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : ||              \
1030             { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
1031         fi
1032
1033 # Update the hash stored above.  Do this after each release and
1034 # for any corrections to old entries.
1035 update-NEWS-hash: NEWS
1036         perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1037           $(srcdir)/cfg.mk
1038
1039 # Ensure that we use only the standard $(VAR) notation,
1040 # not @...@ in Makefile.am, now that we can rely on automake
1041 # to emit a definition for each substituted variable.
1042 # However, there is still one case in which @VAR@ use is not just
1043 # legitimate, but actually required: when augmenting an automake-defined
1044 # variable with a prefix.  For example, gettext uses this:
1045 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1046 # otherwise, makeinfo would put German or French (current locale)
1047 # navigation hints in the otherwise-English documentation.
1048 #
1049 # Allow the package to add exceptions via a hook in cfg.mk;
1050 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1051 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1052 _makefile_at_at_check_exceptions ?=
1053 sc_makefile_at_at_check:
1054         @perl -ne '/\@[A-Z_0-9]+\@/'                                    \
1055           -e ' && !/([A-Z_0-9]+)\s+=.*\@\1\@$$/'                        \
1056           -e ''$(_makefile_at_at_check_exceptions)                      \
1057           -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}'    \
1058             $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1059           && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1060
1061 news-check: NEWS
1062         if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS              \
1063             | grep -E $(news-check-regexp) >/dev/null; then             \
1064           :;                                                            \
1065         else                                                            \
1066           echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2;      \
1067           exit 1;                                                       \
1068         fi
1069
1070 sc_makefile_TAB_only_indentation:
1071         @prohibit='^    [ ]{8}'                                         \
1072         in_vc_files='akefile|\.mk$$'                                    \
1073         halt='found TAB-8-space indentation'                            \
1074           $(_sc_search_regexp)
1075
1076 sc_m4_quote_check:
1077         @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]'              \
1078         in_vc_files='(^configure\.ac|\.m4)$$'                           \
1079         halt='quote the first arg to AC_DEF*'                           \
1080           $(_sc_search_regexp)
1081
1082 fix_po_file_diag = \
1083 'you have changed the set of files with translatable diagnostics;\n\
1084 apply the above patch\n'
1085
1086 # Verify that all source files using _() are listed in po/POTFILES.in.
1087 po_file ?= $(srcdir)/po/POTFILES.in
1088 generated_files ?= $(srcdir)/lib/*.[ch]
1089 generated_files_sharing_po = \
1090   $(if $(wildcard $(srcdir)/lib/po/POTFILES.in),,$(generated_files))
1091 sc_po_check:
1092         @if test -f $(po_file); then                                    \
1093           grep -E -v '^(#|$$)' $(po_file)                               \
1094             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
1095           files=;                                                       \
1096           for file in $$($(VC_LIST_EXCEPT))                             \
1097               $(generated_files_sharing_po); do                         \
1098             test -r $$file || continue;                                 \
1099             case $$file in                                              \
1100               *.m4|*.mk) continue ;;                                    \
1101               *.?|*.??) ;;                                              \
1102               *) continue;;                                             \
1103             esac;                                                       \
1104             case $$file in                                              \
1105             *.[ch])                                                     \
1106               base=`expr " $$file" : ' \(.*\)\..'`;                     \
1107               { test -f $$base.l || test -f $$base.y; } && continue;;   \
1108             esac;                                                       \
1109             files="$$files $$file";                                     \
1110           done;                                                         \
1111           grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files          \
1112             | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2;      \
1113           diff -u -L $(po_file) -L $(po_file) $@-1 $@-2                 \
1114             || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; };   \
1115           rm -f $@-1 $@-2;                                              \
1116         fi
1117
1118 # Sometimes it is useful to change the PATH environment variable
1119 # in Makefiles.  When doing so, it's better not to use the Unix-centric
1120 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
1121 msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
1122 sc_makefile_path_separator_check:
1123         @prohibit='PATH[=].*:'                                          \
1124         in_vc_files='akefile|\.mk$$'                                    \
1125         halt=$(msg)                                                     \
1126           $(_sc_search_regexp)
1127
1128 # Check that `make alpha' will not fail at the end of the process,
1129 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1130 # and is read-only.
1131 writable-files:
1132         if test -d $(release_archive_dir); then                         \
1133           for file in $(DIST_ARCHIVES); do                              \
1134             for p in ./ $(release_archive_dir)/; do                     \
1135               test -e $$p$$file || continue;                            \
1136               test -w $$p$$file                                         \
1137                 || { echo ERROR: $$p$$file is not writable; fail=1; };  \
1138             done;                                                       \
1139           done;                                                         \
1140           test "$$fail" && exit 1 || : ;                                \
1141         else :;                                                         \
1142         fi
1143
1144 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1145 sample-test = tests/sample-test
1146 texi = doc/$(PACKAGE).texi
1147 # Make sure that the copyright date in $(v_etc_file) is up to date.
1148 # Do the same for the $(sample-test) and the main doc/.texi file.
1149 sc_copyright_check:
1150         @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };'            \
1151         in_files=$(v_etc_file)                                          \
1152         halt='out of date copyright in $(v_etc_file); update it'        \
1153           $(_sc_search_regexp)
1154         @require='# Copyright \(C\) '$$(date +%Y)' Free'                \
1155         in_vc_files=$(sample-test)                                      \
1156         halt='out of date copyright in $(sample-test); update it'       \
1157           $(_sc_search_regexp)
1158         @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free'       \
1159         in_vc_files=$(texi)                                             \
1160         halt='out of date copyright in $(texi); update it'              \
1161           $(_sc_search_regexp)
1162
1163 # If tests/help-version exists and seems to be new enough, assume that its
1164 # use of init.sh and path_prepend_ is correct, and ensure that every other
1165 # use of init.sh is identical.
1166 # This is useful because help-version cross-checks prog --version
1167 # with $(VERSION), which verifies that its path_prepend_ invocation
1168 # sets PATH correctly.  This is an inexpensive way to ensure that
1169 # the other init.sh-using tests also get it right.
1170 _hv_file ?= $(srcdir)/tests/help-version
1171 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1172 # Fix syntax-highlighters "
1173 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1174 sc_cross_check_PATH_usage_in_tests:
1175         @if test -f $(_hv_file); then                                   \
1176           grep -l 'VERSION mismatch' $(_hv_file) >/dev/null             \
1177             || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2;    \
1178                  exit 0; };                                             \
1179           grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null         \
1180             || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1181                  exit 1; };                                             \
1182           good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file));           \
1183           grep -LFx "$$good"                                            \
1184                 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT)))  \
1185               | grep . &&                                               \
1186             { echo "$(ME): the above files use path_prepend_ inconsistently" \
1187                 1>&2; exit 1; } || :;                                   \
1188         fi
1189
1190 # #if HAVE_... will evaluate to false for any non numeric string.
1191 # That would be flagged by using -Wundef, however gnulib currently
1192 # tests many undefined macros, and so we can't enable that option.
1193 # So at least preclude common boolean strings as macro values.
1194 sc_Wundef_boolean:
1195         @prohibit='^#define.*(yes|no|true|false)$$'                     \
1196         in_files='$(CONFIG_INCLUDE)'                                    \
1197         halt='Use 0 or 1 for macro values'                              \
1198           $(_sc_search_regexp)
1199
1200 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1201 # not be constant, or might overflow a stack.  In general, use PATH_MAX as
1202 # a limit, not an array or alloca size.
1203 sc_prohibit_path_max_allocation:
1204         @prohibit='(\balloca *\([^)]*|\[[^]]*)PATH_MAX'                 \
1205         halt='Avoid stack allocations of size PATH_MAX'                 \
1206           $(_sc_search_regexp)
1207
1208 sc_vulnerable_makefile_CVE-2009-4029:
1209         @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1210         in_files=$$(find $(srcdir) -name Makefile.in)                   \
1211         halt=$$(printf '%s\n'                                           \
1212           'the above files are vulnerable; beware of running'           \
1213           '  "make dist*" rules, and upgrade to fixed automake'         \
1214           '  see http://bugzilla.redhat.com/542609 for details')        \
1215           $(_sc_search_regexp)
1216
1217 vc-diff-check:
1218         (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1219         if test -s vc-diffs; then                               \
1220           cat vc-diffs;                                         \
1221           echo "Some files are locally modified:" 1>&2;         \
1222           exit 1;                                               \
1223         else                                                    \
1224           rm vc-diffs;                                          \
1225         fi
1226
1227 rel-files = $(DIST_ARCHIVES)
1228
1229 gnulib_dir ?= $(srcdir)/gnulib
1230 gnulib-version = $$(cd $(gnulib_dir) && git describe)
1231 bootstrap-tools ?= autoconf,automake,gnulib
1232
1233 # If it's not already specified, derive the GPG key ID from
1234 # the signed tag we've just applied to mark this release.
1235 gpg_key_ID ?= \
1236   $$(git cat-file tag v$(VERSION) \
1237      | gpgv --status-fd 1 --keyring /dev/null - - 2>/dev/null \
1238      | sed -n '/^\[GNUPG:\] ERRSIG /{s///;s/ .*//p;q}')
1239
1240 translation_project_ ?= coordinator@translationproject.org
1241
1242 # Make info-gnu the default only for a stable release.
1243 ifeq ($(RELEASE_TYPE),stable)
1244   announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1245   announcement_mail_headers_ ?=                                         \
1246     To: info-gnu@gnu.org                                                \
1247     Cc: $(announcement_Cc_)                                             \
1248     Mail-Followup-To: $(PACKAGE_BUGREPORT)
1249 else
1250   announcement_Cc_ ?= $(translation_project_)
1251   announcement_mail_headers_ ?=                                         \
1252     To: $(PACKAGE_BUGREPORT)                                            \
1253     Cc: $(announcement_Cc_)
1254 endif
1255
1256 announcement: NEWS ChangeLog $(rel-files)
1257         @$(srcdir)/$(_build-aux)/announce-gen                           \
1258             --mail-headers='$(announcement_mail_headers_)'              \
1259             --release-type=$(RELEASE_TYPE)                              \
1260             --package=$(PACKAGE)                                        \
1261             --prev=$(PREV_VERSION)                                      \
1262             --curr=$(VERSION)                                           \
1263             --gpg-key-id=$(gpg_key_ID)                                  \
1264             --news=$(srcdir)/NEWS                                       \
1265             --bootstrap-tools=$(bootstrap-tools)                        \
1266             --gnulib-version=$(gnulib-version)                          \
1267             --no-print-checksums                                        \
1268             $(addprefix --url-dir=, $(url_dir_list))
1269
1270 ## ---------------- ##
1271 ## Updating files.  ##
1272 ## ---------------- ##
1273
1274 ftp-gnu = ftp://ftp.gnu.org/gnu
1275 www-gnu = http://www.gnu.org
1276
1277 upload_dest_dir_ ?= $(PACKAGE)
1278 emit_upload_commands:
1279         @echo =====================================
1280         @echo =====================================
1281         @echo "$(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \\"
1282         @echo "    --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1283         @echo "  $(rel-files)"
1284         @echo '# send the ~/announce-$(my_distdir) e-mail'
1285         @echo =====================================
1286         @echo =====================================
1287
1288 define emit-commit-log
1289   printf '%s\n' 'maint: post-release administrivia' ''                  \
1290     '* NEWS: Add header line for next release.'                         \
1291     '* .prev-version: Record previous version.'                         \
1292     '* cfg.mk (old_NEWS_hash): Auto-update.'
1293 endef
1294
1295 .PHONY: no-submodule-changes
1296 no-submodule-changes:
1297         if test -d $(srcdir)/.git; then                                 \
1298           diff=$$(cd $(srcdir) && git submodule -q foreach              \
1299                   git diff-index --name-only HEAD)                      \
1300             || exit 1;                                                  \
1301           case $$diff in '') ;;                                         \
1302             *) echo '$(ME): submodule files are locally modified:';     \
1303                 echo "$$diff"; exit 1;; esac;                           \
1304         else                                                            \
1305           : ;                                                           \
1306         fi
1307
1308 submodule-checks ?= no-submodule-changes public-submodule-commit
1309
1310 # Ensure that each sub-module commit we're using is public.
1311 # Without this, it is too easy to tag and release code that
1312 # cannot be built from a fresh clone.
1313 .PHONY: public-submodule-commit
1314 public-submodule-commit:
1315         $(AM_V_GEN)if test -d $(srcdir)/.git; then                      \
1316           cd $(srcdir) &&                                               \
1317           git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1318               = '$$(git merge-base origin $$sha1)'                      \
1319             || { echo '$(ME): found non-public submodule commit' >&2;   \
1320                  exit 1; };                                             \
1321         else                                                            \
1322           : ;                                                           \
1323         fi
1324 # This rule has a high enough utility/cost ratio that it should be a
1325 # dependent of "check" by default.  However, some of us do occasionally
1326 # commit a temporary change that deliberately points to a non-public
1327 # submodule commit, and want to be able to use rules like "make check".
1328 # In that case, run e.g., "make check gl_public_submodule_commit="
1329 # to disable this test.
1330 gl_public_submodule_commit ?= public-submodule-commit
1331 check: $(gl_public_submodule_commit)
1332
1333 .PHONY: alpha beta stable
1334 ALL_RECURSIVE_TARGETS += alpha beta stable
1335 alpha beta stable: syntax-check writable-files $(submodule-checks)
1336         test $@ = stable                                                \
1337           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$'         \
1338                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1339           || :
1340         $(MAKE) vc-diff-check
1341         $(MAKE) news-check
1342         $(MAKE) distcheck
1343         $(MAKE) dist XZ_OPT=-9ev
1344         $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1345         $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1346
1347 # Override this in cfg.mk if you follow different procedures.
1348 release-prep-hook ?= release-prep
1349
1350 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1351 .PHONY: release-prep
1352 release-prep:
1353         case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1354           *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1355         $(MAKE) --no-print-directory -s announcement > ~/announce-$(my_distdir)
1356         if test -d $(release_archive_dir); then                 \
1357           ln $(rel-files) $(release_archive_dir);               \
1358           chmod a-w $(rel-files);                               \
1359         fi
1360         echo $(VERSION) > $(prev_version_file)
1361         $(MAKE) update-NEWS-hash
1362         perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
1363         $(emit-commit-log) > .ci-msg
1364         $(VC) commit -F .ci-msg -a
1365         rm .ci-msg
1366
1367 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1368 # if the default $(PACKAGE)-derived name doesn't apply.
1369 gendocs_options_ ?=
1370
1371 .PHONY: web-manual
1372 web-manual:
1373         @test -z "$(manual_title)" \
1374           && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1375         @cd '$(srcdir)/doc'; \
1376           $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
1377              -o '$(abs_builddir)/doc/manual' \
1378              --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1379             "$(PACKAGE_NAME) - $(manual_title)"
1380         @echo " *** Upload the doc/manual directory to web-cvs."
1381
1382 # Code Coverage
1383
1384 init-coverage:
1385         $(MAKE) $(AM_MAKEFLAGS) clean
1386         lcov --directory . --zerocounters
1387
1388 COVERAGE_CCOPTS ?= "-g --coverage"
1389 COVERAGE_OUT ?= doc/coverage
1390
1391 build-coverage:
1392         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1393         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1394         mkdir -p $(COVERAGE_OUT)
1395         lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1396                 --capture
1397
1398 gen-coverage:
1399         genhtml --output-directory $(COVERAGE_OUT) \
1400                 $(COVERAGE_OUT)/$(PACKAGE).info \
1401                 --highlight --frames --legend \
1402                 --title "$(PACKAGE_NAME)"
1403
1404 coverage: init-coverage build-coverage gen-coverage
1405
1406 # Update gettext files.
1407 PACKAGE ?= $(shell basename $(PWD))
1408 PO_DOMAIN ?= $(PACKAGE)
1409 PODIR ?= po
1410 RSYNC_OPTIONS = -iz
1411 RSYNC_PROTECT ?= en@boldquot.po en@quot.po
1412 .PHONY: refresh-po
1413 refresh-po:
1414         @echo "$(ME): getting translations into $(PODIR)..."
1415         rsync $(RSYNC_OPTIONS) -Lrc --delete \
1416         $(patsubst %,-f 'protect %',$(RSYNC_PROTECT)) \
1417         -f 'include *.po' -f 'exclude *' \
1418         translationproject.org::tp/latest/$(PO_DOMAIN)/ $(PODIR)
1419         @touch $(PODIR)/LINGUAS
1420         sed -i -e '/^[a-z]/d' $(PODIR)/LINGUAS
1421         { echo 'en@boldquot'; echo 'en@quot'; ls $(PODIR)/*.po; } \
1422         | sed -e 's/\.po//' -e 's,$(PODIR)/,,' | sort -u >> $(PODIR)/LINGUAS
1423
1424  # Running indent once is not idempotent, but running it twice is.
1425 INDENT_SOURCES ?= $(C_SOURCES)
1426 .PHONY: indent
1427 indent:
1428         indent $(INDENT_STYLE) $(INDENT_SOURCES)
1429         indent $(INDENT_STYLE) $(INDENT_SOURCES)
1430
1431 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1432 # put the assignments in this variable.
1433 update-copyright-env ?=
1434
1435 # Run this rule once per year (usually early in January)
1436 # to update all FSF copyright year lists in your project.
1437 # If you have an additional project-specific rule,
1438 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1439 # By default, exclude all variants of COPYING; you can also
1440 # add exemptions (such as ChangeLog..* for rotated change logs)
1441 # in the file .x-update-copyright.
1442 .PHONY: update-copyright
1443 update-copyright:
1444         grep -l -w Copyright                                             \
1445           $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1446           | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
1447
1448 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1449 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1450
1451 # NOTE: to override any _gl_TS_* default value, you must
1452 # define the variable(s) using "export" in cfg.mk.
1453 _gl_TS_dir ?= src
1454
1455 ALL_RECURSIVE_TARGETS += sc_tight_scope
1456 sc_tight_scope: tight-scope.mk
1457         @fail=0;                                                        \
1458         if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk        \
1459                 > /dev/null                                             \
1460            && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1461                 > /dev/null 2>&1; then                                  \
1462             echo '$(ME): skipping $@';                                  \
1463         else                                                            \
1464             $(MAKE) -s -C $(_gl_TS_dir)                                 \
1465                 -f Makefile                                             \
1466                 -f $(abs_top_srcdir)/cfg.mk                             \
1467                 -f $(abs_top_builddir)/$<                               \
1468               _gl_tight_scope                                           \
1469                 || fail=1;                                              \
1470         fi;                                                             \
1471         rm -f $<;                                                       \
1472         exit $$fail
1473
1474 tight-scope.mk: $(ME)
1475         @rm -f $@ $@-t
1476         @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
1477         @chmod a=r $@-t && mv $@-t $@
1478
1479 ifeq (a,b)
1480 # TS-start
1481
1482 # Most functions should have static scope.
1483 # Any that don't must be marked with `extern', but `main'
1484 # and `usage' are exceptions: they're always extern, but
1485 # do not need to be marked.  Symbols matching `__.*' are
1486 # reserved by the compiler, so are automatically excluded below.
1487 _gl_TS_unmarked_extern_functions ?= main usage
1488 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) *\(/
1489
1490 # If your project uses a macro like "XTERN", then put
1491 # the following in cfg.mk to override this default:
1492 # export _gl_TS_extern = extern|XTERN
1493 _gl_TS_extern ?= extern
1494
1495 # The second nm|grep checks for file-scope variables with `extern' scope.
1496 # Without gnulib's progname module, you might put program_name here.
1497 # Symbols matching `__.*' are reserved by the compiler,
1498 # so are automatically excluded below.
1499 _gl_TS_unmarked_extern_vars ?=
1500
1501 # NOTE: the _match variables are perl expressions -- not mere regular
1502 # expressions -- so that you can extend them to match other patterns
1503 # and easily extract matched variable names.
1504 # For example, if your project declares some global variables via
1505 # a macro like this: GLOBAL(type, var_name, initializer), then you
1506 # can override this definition to automatically extract those names:
1507 # export _gl_TS_var_match = \
1508 #   /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1509 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1510
1511 # The names of object files in (or relative to) $(_gl_TS_dir).
1512 _gl_TS_obj_files ?= *.$(OBJEXT)
1513
1514 # Files in which to search for the one-line style extern declarations.
1515 # $(_gl_TS_dir)-relative.
1516 _gl_TS_headers ?= $(noinst_HEADERS)
1517
1518 .PHONY: _gl_tight_scope
1519 _gl_tight_scope: $(bin_PROGRAMS)
1520         t=exceptions-$$$$;                                              \
1521         trap 's=$$?; rm -f $$t; exit $$s' 0;                            \
1522         for sig in 1 2 3 13 15; do                                      \
1523           eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1524         done;                                                           \
1525         src=`for f in $(SOURCES); do                                    \
1526                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1527         hdr=`for f in $(_gl_TS_headers); do                             \
1528                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1529         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions);  \
1530           grep -h -A1 '^extern .*[^;]$$' $$src                          \
1531             | grep -vE '^(extern |--)' | sed 's/ .*//';                 \
1532           perl -lne                                                     \
1533              '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr;      \
1534         ) | sort -u > $$t;                                              \
1535         nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
1536           && { echo the above functions should have static scope >&2;   \
1537                exit 1; } || : ;                                         \
1538         ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars);       \
1539           perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h \
1540         ) | sort -u > $$t;                                              \
1541         nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p'          \
1542             | sort -u | grep -Ev -f $$t                                 \
1543           && { echo the above variables should have static scope >&2;   \
1544                exit 1; } || :
1545 # TS-end
1546 endif